import java.util.*;

public class Sample {  
  public static void main(String[] args) {
    //Why Modules?
    
    //It is not about you and me
    
    //In Java 8, rt.jar was well over 68M
    //The world today is very different from the early years of Java
    //Cloud, Microservices, Microkernels,... Lambas (function as service
    //server less application)...
    //Small footprint is necessary
    
    //break Java into smaller pieces
    //try 
    //java --list-modules
    //java --list-modules | wc -l
    //Java 9 had about 98 modules
    //Java 10 had about 78 modules
    //Java 11 had about 70 modules
    //Java has been modulalized and trimmed
    
    //Smaller more cohesive pieces/modules
    //More secure old stuff run in classpath, new stuff can run
    //in a more secure module path
    //Two modules can't have the same package
    //Public is no longer public, public + exports is public otherwise
    //it is hidden within the package
    //At code time or at runtime using reflection we can't access
    //what is not explicitly provided / exported to us
    
    //fail fast - if something is missing, then the code does not even
    //start.
    
    //The module dependencies are kept with the modules as part of the
    //metadata
    
    //jar -f filename.jar -d
    
    /*
      Improvements:
      
      Language:
        private interface method
        try-with-resource can have object from outside scope
        _ was removed
      
      JDK:
        finalize has been deprecated
        Stream's API has evolved with methods like takeWhile and dropWhile
        Optional has a few extra methods
        List.of, Set.of,...
        ...
    
    */
    
  }
}