//smart casting will be in Java eventually

/*
  In current Java
  if(input instanceof String) {
    int length = ((String)(input)).length();
    //casting as punishment
  }
*/

fun process(input: Any): String {
  //val l = input.length //ERROR
  //Any (Object) does not have length
  
  return when(input) {
    1 -> "got one"
    is String -> "got a string of length ${input.length}"
    //smart cast above makes it easy to use length
    else -> "whatever"
  }
}

println(process(1))
println(process("hello"))