//Eventually in Java, we can use Pattern Matching with
//Record (data classes), for example:

case class Person(val first: String, val last: String)

def process(input: Any) = {
  input match {
    case 1 => println("You got one")
    case "hello" => println("well hello")
    case Person(f, l) => println(s"$f $l")
  }
}

process(1)
process("hello")
process(new Person("Alan", "Turing"))